//---------------------------------------------------------------------------
#ifndef TCDirTreeH
#define TCDirTreeH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <Dsgnintf.hpp>
#include <ComCtrls.hpp>
#include <shellapi.h>



namespace Dirtree
{

typedef struct FNodeListItem
{
  String Name;
  bool   HasDirectories;
} TNoLi , *PTNoLi;

class PACKAGE TCDirTree;
class TReLevelTh : public TThread
{
private:
    TTreeNodes*  FItems;
    TList*       FNodeList;
    TTreeNode*   FRootNode;
    TTreeNode*   FNode;
    int          FCurIndex;
    String       FName;
    String       FPath;
       bool use;
protected:
    virtual void __fastcall Execute();
    void __fastcall AddNode();
    void __fastcall Done();
public:
  __fastcall TReLevelTh(TTreeNodes *Items,String Path,TTreeNode *RootNode);
  //void __fastcall DoChangeInt();
  __fastcall ~TReLevelTh(){}
};
//---------------------------------------------------------------------------
        enum TTextCase { tcLowerCase, tcUpperCase, tcAsIs };
        typedef void __fastcall (__closure * TDirectoryChangeEvent)
                                (System::TObject* Sender,
                                 const AnsiString NewDir);

//---------------------------------------------------------------------------
typedef struct DriveNode
{
   int Drive;
   int BitMap;
   int type;
   TTreeNode *Node;
} TDriveNode;

typedef TDriveNode* PDriveNode;
//---------------------------------------------------------------------------

class PACKAGE TCDirTree : public TCustomTreeView
{
private:
   friend class TReLevelTh;
   TList *LDrives;
   TImageList *ImagesList;
   SHFILEINFO InformacionDirectorios;
   bool Loading;
   static void* APointer;
   static void* tmpPointer;
   char FDrive;
   TFileName FDirectory;


   TTextCase FTextCase;
   typedef AnsiString (__fastcall *TCaseFunction)(const AnsiString AString);
   TCaseFunction FCaseFunction;


   TDriveNode* __fastcall GetLDriveItem(int Drive);

 //  virtual void __fastcall WndProc(Messages::TMessage & Message);

   static int __fastcall DriveToInt(char);
   static char __fastcall IntToDrive(int);


protected:

    TDirectoryChangeEvent FOnDirectoryChange;

    void __fastcall SetDrive(char NewDrive);
    void __fastcall SetTextCase(TTextCase NewTextCase);
    void __fastcall AssignCaseProc();
    void __fastcall WalkTree(const AnsiString& Dest);

    virtual bool __fastcall BuildOneLevel(TTreeNode *RootItemNode);
    virtual void __fastcall ChangePath(AnsiString &Path);
    virtual void __fastcall BuildDrive(PDriveNode sNode);
    virtual void __fastcall BuildAllDrives();

    TTreeNode* __fastcall GetChildNamed(const AnsiString& Name,TTreeNode* Item);

    // virtual overrides from base
    virtual void __fastcall CreateWnd();
    virtual void __fastcall Loaded();
    DYNAMIC void __fastcall Click();
    DYNAMIC void __fastcall Expand(TTreeNode *Node);
    DYNAMIC void __fastcall Change(TTreeNode *Node);

    // helper statics
    static AnsiString CurDir();
public:
    virtual __fastcall TCDirTree(TComponent* Owner);
     __fastcall TCDirTree(HWND Parent):TCustomTreeView(Parent) {};
    virtual __fastcall ~TCDirTree();

    AnsiString __fastcall ForceCase(const AnsiString& AString);

        void __fastcall SetDirectory(TFileName NewDirectory);
        void __fastcall GoParent();
    __property char Drive = { read = FDrive, write = SetDrive };
    __property TFileName Directory =
            { read = FDirectory, write = SetDirectory };


__published:

    // new properties
    __property TDirectoryChangeEvent OnDirectoryChange = { read = FOnDirectoryChange,
                                                  write = FOnDirectoryChange };
//
    __property TTextCase TextCase = { read = FTextCase, write = SetTextCase };
                               // stored
    // properties from base classes
    __property Align;
    __property BorderStyle;
    __property Color;
    __property Ctl3D;
    __property Images;
    __property DragCursor;
    __property DragMode;
    __property Enabled;
    __property Font;
    __property OnClick;
    __property OnCollapsing;
    __property OnDblClick;
    __property OnDragDrop;
    __property OnDragOver;
    __property OnEndDrag;
    __property OnEnter;
    __property OnExit;
    __property OnExpanding;
    __property OnExpanded;
    __property OnKeyDown;
    __property OnKeyPress;
    __property OnKeyUp;
    __property OnMouseDown;
    __property OnMouseMove;
    __property OnMouseUp;
    __property ParentColor;
    __property ParentCtl3D;
    __property ParentFont;
    __property ParentShowHint;
    __property PopupMenu;
    __property ShowHint;
    __property TabOrder;
    __property TabStop;
    __property Visible;
};

class PACKAGE TCThDirTree : public TCDirTree
{
  public:
  __fastcall TCThDirTree(HWND Parent):TCDirTree(Parent) {};
  protected:
       DYNAMIC void __fastcall Expand(TTreeNode *Node);
__published:
    __property OnDirectoryChange;
    __property Align;
    __property BorderStyle;
    __property Color;
    __property Ctl3D;
    __property Images;
    __property DragCursor;
    __property DragMode;
    __property Enabled;
    __property Font;
    __property OnClick;
    __property OnCollapsing;
    __property OnDblClick;
    __property OnDragDrop;
    __property OnDragOver;
    __property OnEndDrag;
    __property OnEnter;
    __property OnExit;
    __property OnExpanding;
    __property OnExpanded;
    __property OnKeyDown;
    __property OnKeyPress;
    __property OnKeyUp;
    __property OnMouseDown;
    __property OnMouseMove;
    __property OnMouseUp;
    __property ParentColor;
    __property ParentCtl3D;
    __property ParentFont;
    __property ParentShowHint;
    __property PopupMenu;
    __property ShowHint;
    __property TabOrder;
    __property TabStop;
    __property Visible;

};
//---------------------------------------------------------------------------
class  TCDirTreeEditor : public Dsgnintf::TComponentEditor
{
  public:
  void __fastcall Edit(void);
};
//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Fileoper */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dirtree;
#endif
//-- end .h ----------------------------------------------------------------
#endif	// namespace Dirtree

